; Transl89 (Translator 89 Beta)
; by Alban Gervaise
; written on PlusShell v1.0a
; last release 21/04/99


        include "tios.h"

        xdef _ti89
        xdef _main
        xdef _nostub

_DEREF macro                ; so must write deref MACRO
 lsl.w #2,\1
 GET_REL_RAM_DWORD $2f,$104+$16,\2
 move.l 0(\2,\1.w),\2
 endm


GET_REL_RAM_DWORD macro
 move.l ($c8),a5
 add.l #\1*4,a5
 move.l (a5),a5
 move.l \2(a5),\3
 endm

_begin              
        bra _main   
        cnop 0,4
        dc.b "68kP"
        dc.w 0
        dc.w _comment-_begin
        dc.w _main-_begin
        dc.w 0,3,0,0,0,0,0,0,0,0,0,0

_main
        movem.l d0-d7/a0-a6,-(a7)

        bclr.b #0,flag

        move.l ($76fc),a1 ; ici on regarde si il y a un argument
        cmp.b #$E5,(a1)   ; si non alors erreur: "too few arguments"
        beq make_error_0  ;        
        cmp.b #45,(a1)    ; et si il s'agit bien d'un string       
        bne make_error_1  ; si non alors erreur: "argument must be a string"


noabout sub.l #1,a1         ; on se place au debut du string
        clr.w d0            ;
\loop   add.w #1,d0         ; 
        tst.B -(a1)         ;
        bne.s \loop         ;
        sub.w #1,d0         ;
        move.w d0,taille    ; et au passage on prend sa taille

        cmp.b #$e5,-1(a1)
        beq.s go
        cmp.b #'?',-3(a1)
        beq about
        cmp.b #'c',-3(a1)
        bne help
        bset.b #0,flag

go      lea 1(a1),a1        ; on copie le string dans mot
        move.l a1,mot       ; on sauve l'adresse du mot

        lea.l handle(pc),a0         ; la on s'occupe de savoir s'il y a de la place pour les resultats
        tst.w (a0)                  ; does already exist a handle?
        beq.s \create               ; no so create it
        move.w (a0),d0              ; but is it a good handle?
        _DEREF d0,a0
        pea.l id(pc)
        move.l a0,-(a7)
        ROM_CALL romfunc::strcmp
        lea 8(a7),a7
        tst.w d0
        beq.s \bon                  ; yes so take it
\create move.l #1000,-(a7)          ; no so alloc a new one
        ROM_CALL romfunc::HeapAlloc
        lea 4(a7),a7
        tst.w d0
        beq make_error_4
        lea.l handle(pc),a0
        move.w d0,(a0)
\bon    lea.l handle(pc),a0
        move.w (a0),d0              ; now d0=handle
        _DEREF d0,a1
        lea.l id(pc),a0
        moveq.w #29,d0
\copyid move.b (a0)+,(a1)+
        dbra.s d0,\copyid
        move.b #229,(a1)+
        move.l a1,addr

        clr.w count         ; ici on cherche combien de string sont bons...
        moveq #8,d0
        _DEREF d0,a0
        lea 2(a0),a0
        move.w (a0)+,d0
        sub.w #1,d0
\loopd0 move.w 12(a0),d1
        _DEREF d1,a1
        lea 2(a1),a1
        move.w (a1)+,d1
        tst.w d1
        beq.s \skip
        sub.w #1,d1
\loopd1 move.w 12(a1),d2
        _DEREF d2,a2
        lea 2(a2),a2
        cmp.l #$00543839,(a2)
        bne.s \non
        add.w #1,count
\non    lea 14(a1),a1
        dbra.s d1,\loopd1
\skip   lea 14(a0),a0
        dbra.s d0,\loopd0
        tst.w count
        beq make_error_2

        clr.l d0
        move.w count,d0
        lsl.l #2,d0
        move.l d0,-(a7)
        ROM_CALL romfunc::HeapAlloc
        lea 4(a7),a7
        tst.w d0
        beq make_error_4

        move.w d0,handle_list
        _DEREF d0,a3
        move.l a3,list

        moveq #8,d0
        _DEREF d0,a0
        lea 2(a0),a0
        move.w (a0)+,d0
        sub.w #1,d0
loopd02 move.w 12(a0),d1
        _DEREF d1,a1
        lea 2(a1),a1
        move.w (a1)+,d1
        tst.w d1
        beq.s skip2
        sub.w #1,d1
loopd12 move.w 12(a1),d2
        _DEREF d2,a2
        lea 2(a2),a2
        cmp.l #$00543839,(a2)
        bne.s non2
        move.l a2,(a3)+
non2    lea 14(a1),a1
        dbra.s d1,loopd12
skip2   lea 14(a0),a0
        dbra.s d0,loopd02


file_loop:
        tst.w count         ; si count=0 alors il n'y a plus de fichier dans la liste
        beq make_error_3    ; erreur 3: "No translation found"

        sub.w #1,count
        move.l list,a0
        clr.l d0
        move.w count,d0
        lsl.l #2,d0
        move.l 0(a0,d0.w),a0
        lea.l 5(a0),a0

\search tst.b (a0)
        beq file_loop
        cmp.b #124,(a0)+
        bne.s \search

main_loop:        
        bsr str_cmp
        tst.w d0
        beq.s found
        tst.b (a0)+
        beq file_loop
        bra.s main_loop

found   move.l a0,search
        cmp.b #':',-1(a0)
        beq.s \ok
        cmp.b #',',-1(a0)
        beq.s \ok
        cmp.b #124,-1(a0)
        beq.s \ok
        btst.b #0,flag
        bne.s \skip
        cmp.b #' ',-1(a0)
        beq.s \ok
\skip   addq.l #1,a0
        bra.s main_loop
\ok
        add.w taille,a0 ; on a trouve le mot et a0 pointe sur le debut de celui-ci
        cmp.b #':',(a0)
        beq.s copy_traduction
        btst.b #0,flag
        bne.s \saute
        cmp.b #' ',(a0)
        beq.s autre2
\saute  cmp.b #124,(a0)
        beq.s autre1
        tst.b (a0)
        beq.s autre1
        cmp.b #',',(a0)
        beq.s autre2
        bra file_loop

autre1  cmp.b #124,-(a0)
        beq.S copy_traduction
        tst.b (a0)
        bne.S autre1
        bra file_loop

autre2  add.l #1,a0
        tst.b (a0)
        beq.S autre1
        cmp.b #124,(a0)
        beq.s autre1
        cmp.b #':',(a0)
        bne.s autre2

copy_traduction:
        add.l #1,a0
        move.l addr,a1
        clr.b (a1)+

\copy   tst.b (a0)
        beq.s \fini
        cmp.b #':',(a0)
        beq.s \fini
        cmp.b #124,(a0)
        beq.S \fini
        move.b (a0)+,(a1)+
        bra.s \copy
\fini   clr.b (a1)+
        move.b #45,(a1)+
        move.l a1,addr
        move.l search,a0
        add.l #1,a0
        bra main_loop

return  bsr clr_mem
        move.l addr,a1
        move.b #217,(a1)
fin     move.l ($c8),a0
        add.l #$109*4,a0
        move.l (a0),a0
        move.l a1,$12(a0)        
        bra exit


str_cmp move.l a0,-(a7)
        move.l mot,a1
\loop   clr.w d0
        tst.b (a1)
        beq.s \bon
        move.b (a0)+,d0
        cmp.b (a1)+,d0
        beq.s \loop
        move.b #1,d0
\bon    move.l (a7)+,a0
        rts

help    lea.l help_str+36(pc),a1
        bra fin
about   lea.l _comment+38(pc),a1
        bra fin


make_error_0:
        pea.l error_0(pc)
        bra.s disp_error
make_error_1:
        pea.l error_1(pc)
        bra.s disp_error
make_error_2:
        pea.l error_2(pc)
        bra.S disp_error
make_error_3:
        move.l addr,a1
        cmp.b #229,-(a1)
        bne return
        bsr clr_mem
        pea.l error_3(pc)
        bra.s disp_error
make_error_4:
        pea.l error_4(pc)
disp_error
        ROM_CALL romfunc::ST_showHelp
        lea 4(a7),a7
exit    movem.l (a7)+,d0-d7/a0-a6
        rts

clr_mem move.w handle_list,-(a7)
        ROM_CALL romfunc::HeapFree
        lea 2(a7),a7
        rts


list        dc.l 0
handle_list dc.w 0

taille  dc.w 0      ; taille du mot
mot     dc.l 0      ; adresse ou se trouve le mot
count   dc.w 0      ; = nombre de string au bon format dans la ti89
handle  dc.w 0      ; handle du block de memoire qui rendera le resultat
addr    dc.l 0      ; addresse de ce block memoire
search  dc.l 0      ; addresse dans le string ou se situe la recherche
flag    dc.b 0,0

error_0 dc.b "Too few arguments",0
error_1 dc.b "Argument must be string",0
error_2 dc.b "String not found",0
error_3 dc.b "No translation found",0
error_4 dc.b "Not enough memory",0

id       dc.b "Translator 89 reserved memory",0,$e5,0
help_str dc.b "options: c= complete word, ?= about",0,45,$e5,0

_comment dc.b "Translator 89 v1.0",223," by Alban Gervaise",0,45

         end

; Transl89 (Translator 89 v1.0 Beta )
; by Alban Gervaise
; written on PlusShell v1.0a
; last release 21/04/99
