; uninst89  (Uninstall Translator 89)
; by Alban Gervaise
; written on PlusShell v1.0a
; last release 17/04/99

        include "tios.h"

        xdef _ti89
        xdef _nostub

_DEREF macro
 lsl.w #2,\1
 GET_REL_RAM_DWORD $2f,$104+$16,\2
 move.l 0(\2,\1.w),\2
 endm

GET_REL_RAM_WORD macro
 move.l ($c8),a5
 add.l #\1*4,a5
 move.l (a5),a5
 move.w \2(a5),\3
 endm

GET_REL_RAM_DWORD macro
 move.l ($c8),a5
 add.l #\1*4,a5
 move.l (a5),a5
 move.l \2(a5),\3
 endm

_begin  movem.l d0-d7/a0-a6,-(a7)       ; save all registrers
        GET_REL_RAM_WORD $2f,$104,d7    ; numbers of handle
search  move.w d7,-(a7)
        _DEREF d7,a0                    ; give address of the handle
        move.w (a7)+,d7
        move.l a0,-(a7)
        pea.l id(pc)
        ROM_CALL romfunc::strcmp        ; if there the id string?
        lea 8(a7),a7
        tst.w d0
        beq.s bon                       ; yes, so free this handle
skip    dbra.s d7,search                ; restart unless there is no more handle...
        movem.l (a7)+,d0-d7/a0-a6       ; restore the registrers
        rts                             ; and quit

bon     move.w d7,-(a7)                 ; push the handle
        ROM_CALL romfunc::HeapFree      ; free the handle block memory
        lea 2(a7),a7                    ; restore the stack
        bra.s skip                      ; come back to the main loop

id      dc.b "Translator 89 reserved memory",0  ; the id

 end
